## pico-sdk 1.5.1

=== debian/changelog ===
pico-sdk (1.5.1-4) unstable; urgency=medium

  * pico-sdk-source: mark as multi-arch:foreign

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 05 Jun 2024 19:13:44 +0200

pico-sdk (1.5.1-3) unstable; urgency=medium

  * add patch from upstream to support big endian architectures like s390x

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 05 Jun 2024 11:46:58 +0200

pico-sdk (1.5.1-2) unstable; urgency=medium

  * debian/rules: create /usr/src/pico-sdk/docs dummy as CMakeLists.txt
    unconditionally runs add_subdirectory(docs)
  * debian/rules: execute_before_dh_auto_configure: make sure ./lib exists
  * debian/salsa-ci.yml: tests get compiled with arm-none-eabi-gcc and are not
    shipped by any binary package, so no need to check the build log
  * debian/patches: add reproducible_doxygen.patch

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sat, 01 Jun 2024 23:27:44 +0200

pico-sdk (1.5.1-1) unstable; urgency=medium

  * Initial release. (closes: #1069293)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 19 Apr 2024 15:45:29 +0200
