=== debian/tests/control ===
Tests: hello-world
Depends: build-essential, cmake, gcc-arm-none-eabi, libnewlib-arm-none-eabi, libstdc++-arm-none-eabi-newlib, pico-sdk-source
Restrictions: allow-stderr
