## pico-sdk 2.0.0

=== debian/changelog ===
pico-sdk (2.0.0-2) unstable; urgency=medium

  * debian/control: add Depends: picotool (>= 2.0)
  * debian/patches/pioasm.cmake.patch: replace with patch from upstream

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 11 Sep 2024 23:26:36 +0200

pico-sdk (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0
  * add pioasm package shipping the pioasm tool
  * drop 329.patch (swap endian-ness) because elf2uf2 now became 'picotool uf2
    convert'
  * drop patches/repro.patch and set reproducible date via
    PICO_PROGRAM_BUILD_DATE
  * debian/copyright:
     - src/rp2_common/pico_double/double_v1_rom_shim.S had the wrong license
     - directory src/rp2_common/cmsis/stub/CMSIS/Device/RaspberryPi/RP2040 was
       moved to parent
     - src/rp2040/hardware_regs/rp2040.svd got removed
     - drop superfluous License: GPL-2.0
  * debian/pico-sdk-source.lintian-overrides:
    usr/src/pico-sdk/src/rp2_common/pico_stdio/LICENSE got removed
  * debian/tests/control: wrap-and-sort -ast
  * debian/patches/PRIu64.patch: extend to also cover PRIx64 in
    test/pico_float_test/pico_double_test.c
  * debian/rules:
     - build with PICO_NO_PICOTOOL=ON to avoid build-dep loop with picotool
     - split into -arch and -indep targets
     - prevent empty directories in the binary package
  * debian/control: bump Standards-Version (no changes)
  * add lintian-overrides
  * pico-sdk-source: add Depends: cmake, gcc-arm-none-eabi,
    libnewlib-arm-none-eabi, libstdc++-arm-none-eabi-newlib as any user of
    the package most likely wants to compile it

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 06 Sep 2024 22:49:23 +0200
