=== debian/control ===
--- 
+++ 
@@ -5,11 +5,12 @@
 Homepage: https://github.com/raspberrypi/pico-sdk/issues
 Vcs-Browser: https://salsa.debian.org/debian/pico-sdk
 Vcs-Git: https://salsa.debian.org/debian/pico-sdk.git
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
+Build-Depends-Indep:
  doxygen,
  gcc-arm-none-eabi,
  graphviz,
@@ -21,6 +22,13 @@
 Package: pico-sdk-source
 Architecture: all
 Depends:
+ cmake,
+ gcc-arm-none-eabi,
+ libnewlib-arm-none-eabi,
+ libstdc++-arm-none-eabi-newlib,
+ picotool (>= 2.0),
+ pioasm,
+ python3,
  tinyusb-source,
  ${misc:Depends},
 Multi-Arch: foreign
@@ -42,3 +50,14 @@
  The SDK can be used to build anything from simple applications, to fully
  fledged runtime environments such as MicroPython, to low level software such
  as RP2040's on-chip bootrom itself.
+
+Package: pioasm
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Multi-Arch: foreign
+Description: Assemble file of PIO program(s) for use in applications
+ For the development of applications for the Raspberry Pi with the Pico SDK.
+ Available output formats are c-sdk, python, hex, ada and go. The default
+ output is c-skd.
