=== debian/tests/control ===
Tests: hello-world
Depends:
 build-essential,
 pico-sdk-source,
Restrictions: allow-stderr
